routes/web.php
<?php

use App\Http\Controllers\AnswerController;
use App\Http\Controllers\API\CommandController;
use App\Http\Controllers\ButtonsController;
use App\Http\Controllers\CandidatesController;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\PositionController;
use App\Http\Controllers\QuestionsController;
use App\Http\Controllers\ReportController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\API\BookingController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\ExportController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class, 'index'])->name('index');
Route::post('/position/add-question/{position}', [PositionController::class, 'addQuestion'])->name('position.questions');
Route::post('/sendNotifications', [HomeController::class, 'sendNotifications'])->name('sendNotifications');
Route::get('/export/reactions', [ExportController::class,'getReactionsView'])->name('export.reactions.view');
Route::post('/export/get_reactions', [ExportController::class,'getReactionsForExport'])->name('export.get.reactions');
Route::post('/export/reactions', [ExportController::class, 'exportReaction'])->name('export.reaction');
Route::get('/questions', [QuestionsController::class, 'index'])->name('questions.index');
Route::get('/questions/create/{positionId}', [QuestionsController::class, 'create'])->name('questions.create');
Route::post('/questions/store', [QuestionsController::class, 'store'])->name('questions.store');
Route::get('/questions/show/{id}', [QuestionsController::class, 'show'])->name('questions.show');
Route::post('/questions/update', [QuestionsController::class, 'update'])->name('questions.update');
Route::get('/questions/destroy/{id}', [QuestionsController::class, 'destroy'])->name('questions.destroy');

Route::post('/buttons/store', [ButtonsController::class, 'store'])->name('buttons.store');

Route::get('/candidates', [CandidatesController::class, 'index'])->name('candidates.index');
Route::get('/candidates/create', [CandidatesController::class, 'create'])->name('candidates.create');
Route::post('/candidates/store', [CandidatesController::class, 'store'])->name('candidates.store');
Route::get('/candidates/show/{id}', [CandidatesController::class, 'show'])->name('candidates.show');
Route::post('/candidates/delete/{id}', [CandidatesController::class, 'delete'])->name('candidates.delete');
Route::get('botan/staff/get', [HomeController::class, 'showStaff'])->name('showStaff');

Route::get('/report', [ReportController::class, 'index'])->name('report');
Route::resource('company', CompanyController::class);
Route::resource('position', PositionController::class);
Route::get('/admin/command', [CommandController::class, 'command']);

app/Models/Position.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasManyThrough;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Relations\HasOneThrough;

class Position extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'description',
        'company_id',
        'salary',
        'work_schedule'
    ];

    public function company(): HasOne
    {
        return $this->hasOne(Company::class, 'id', 'company_id');
    }

    public function questions(): HasMany
    {
        return $this->hasMany(Question::class, 'position_id', 'id');
    }

    public function answer(): HasManyThrough
    {
        return $this->hasManyThrough(Answer::class, Question::class);
    }

}

app/Http/Controllers/PositionController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PositionRequest;
use App\Models\Company;
use App\Models\Position;
use App\Models\Question;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class PositionController extends Controller
{
    public function index()
    {
        $positions = Position::query()->paginate(15);
        return view('position.index', compact('positions'));
    }

    public function create()
    {
        $companies = Company::query()->get();
        return view('position.create', compact('companies'));
    }

    public function store(PositionRequest $request)
    {
            Position::query()->updateOrCreate($request->validated());
        return redirect(route('position.index'));
    }

    public function show(Position $position)
    {
        $companies = Company::query()->get();
        $questions = Question::query()->get();
        $loopId = 0;
        return view('position.show', compact('position', 'companies', 'questions', 'loopId'));
    }

    public function edit(PositionRequest $request, Position $position)
    {
        $position->updateOrFail($request->validated());
        return redirect(route('position.index'));
    }

    public function destroy(Position $position)
    {
        $position->delete();
        return redirect(route('position.index'));
    }

    public function addQuestion(Position $position, Request $request)
    {
        $questionId = $request->question_id;
//        PositionQuestions::query()->updateOrCreate([
//            'position_id' => $position->id,
//            'question_id' => $questionId
//        ]);
        return redirect(route('position.show', ['position' => $position]));
    }
}

resources/views/position/create.blade.php
@extends('layouts.hr')
@section('content')
    <div id="content-wrapper" style="margin-top: 65px;">
        <div class="container-fluid">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div><br />
            @endif
            <form method="post" action="{{route('position.store')}}">
                @csrf
                <div class="container">
                    <div class="row">
                        <div class="col-md-6">
                            <label for="text">Name</label>
                            <input class="form-control" name="name" id="name" required/>
                        </div>
                        <div class="col-md-6">
                            <label for="company_id">Company</label>
                            <select required class="form-select" name="company_id" id="company_id">
                                <option value="0" disabled selected>Select company</option>
                                @foreach($companies as $company)
                                    <option value="{{$company->id}}">{{$company->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label for="salary">Salary</label>
                            <input class="form-control" type="text" name="salary" id="salary">
                        </div>
                        <div class="col-md-6">
                            <label for="work_schedule">Schedule</label>
                            <input type="text" class="form-control" name="work_schedule" id="work_schedule">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <label for="description">Description</label>
                            <textarea required class="w-100 form-control" name="description" id="description" cols="30" rows="10"></textarea>
                        </div>
                    </div>
                    <button class="btn btn-primary mt-2">Save</button>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/position/index.blade.php
@extends('layouts.hr')
@section('content')
    <div id="content-wrapper" style="margin-top: 65px">
        <div class="container-fluid">
            <h4>Positions</h4>
            <a class="btn btn-primary" href="{{route('position.create')}}">+ Create Position</a>
            <table class="table table-hover">
                <tr>
                    <th>id</th>
                    <th>name</th>
                    <th>Company</th>
                </tr>
                @foreach($positions as $position)
                    <tr>
                        <td>{{$position->id}}</td>
                        <td>{{$position->name}}</td>
                        <td>{{$position->company->name}}</td>
                        <td>
                            <div style="display: flex">
                                <a class="btn btn-primary" href="{{route('position.show', ['position' => $position])}}">edit</a>
                                <form action="{{route('position.destroy', ['position' => $position])}}" method="post">
                                    @method('DELETE')
                                    @csrf
                                    <button class="btn btn-rounded btn-close" type="submit" value="Delete" data-toggle="tooltip" title="Delete!"></button>
                                </form>
                            </div>
                        </td>
                    </tr>
                @endforeach
            </table>
            {{$positions->links()}}
        </div>
    </div>
@endsection

resources/views/position/show.blade.php
@extends('layouts.hr')
@section('content')
    <div id="content-wrapper" style="margin-top: 65px;">
        <div class="container-fluid">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div><br/>
            @endif
            <div class="container">
                <div class="row">
                    <div class="col-md-6">
                        <form action="{{route('position.edit', ['position' => $position])}}">
                            @method('PUT')
                            @csrf
                            <div class="row">
                                <div class="col-md-6">
                                    <div>
                                        <label for="text">Name</label>
                                        <input class="form-control" name="name" id="name" value="{{$position->name}}"/>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <label for="company_id">Company</label>
                                    <select class="form-select" name="company_id" id="company_id">
                                        <option value="0" disabled selected>Select company</option>
                                        @foreach($companies as $company)
                                            <option value="{{$company->id}}"
                                                    @if($position->company->id === $company->id) selected @endif>{{$company->name}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="row">
                                    <div class="col-md-6">
                                        <label for="salary">Salary</label>
                                        <input class="form-control" type="text" name="salary" id="salary" value="{{$position->salary}}">
                                    </div>
                                    <div class="col-md-6">
                                        <label for="work_schedule">Schedule</label>
                                        <input type="text" class="form-control" name="work_schedule" id="work_schedule" value="{{$position->work_schedule}}">
                                    </div>
                                </div>
                                <div class="col-md-12">
                                    <div>
                                        <label for="description">Description</label>
                                        <textarea class="w-100 form-control" name="description" id="description"
                                                  cols="30" rows="10">{{$position->description}}</textarea>
                                    </div>
                                </div>
                                <button class="btn btn-primary mt-2">Update</button>
                            </div>
                        </form>
                    </div>
                    <div class="col-md-6">
                        <div class="row mt-4">
                            <div class="col-md-12">
                                @foreach($position->questions as $question)
                                    @php $loopId = $loopId + 1 @endphp
                                    <div  class="card mb-1" style="display: flex; flex-direction: row; !important; justify-content: space-between !important; padding: 10px 20px">
                                        <a href="{{route('questions.show', ['id' => $question->id])}}" style="cursor: pointer; text-decoration: none; color: black">
                                            <span><b>{{$loopId}})</b> {{$question->text}}</span>
                                        </a>
                                        <a class="btn btn-close" href="{{route('questions.destroy', ['id' => $question->id])}}"></a>
                                    </div>
                                @endforeach
                            </div>
                            <div style="display: flex; justify-content: end">
                                <a href="{{route('questions.create', ['positionId' => $position->id])}}" type="submit" class="btn btn-primary" id="button-add">Add Question</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection